/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.tables.records.VImportLogRecord;

import java.time.LocalDateTime;
import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VImportLog extends TableImpl<VImportLogRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_import_log</code>
     */
    public static final VImportLog V_IMPORT_LOG = new VImportLog();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VImportLogRecord> getRecordType() {
        return VImportLogRecord.class;
    }

    /**
     * The column <code>common_dd.v_import_log.module</code>.
     */
    public final TableField<VImportLogRecord, String> MODULE = createField(DSL.name("module"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_import_log.module_start</code>.
     */
    public final TableField<VImportLogRecord, LocalDateTime> MODULE_START = createField(DSL.name("module_start"), SQLDataType.LOCALDATETIME(6), this, "");

    /**
     * The column <code>common_dd.v_import_log.lastchange</code>.
     */
    public final TableField<VImportLogRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6), this, "");

    /**
     * The column <code>common_dd.v_import_log.pk</code>.
     */
    public final TableField<VImportLogRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_import_log.fk_import_log</code>.
     */
    public final TableField<VImportLogRecord, Integer> FK_IMPORT_LOG = createField(DSL.name("fk_import_log"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_import_log.pseudo_id</code>.
     */
    public final TableField<VImportLogRecord, String> PSEUDO_ID = createField(DSL.name("pseudo_id"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_import_log.measure_id</code>.
     */
    public final TableField<VImportLogRecord, Integer> MEASURE_ID = createField(DSL.name("measure_id"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_import_log.import_date</code>.
     */
    public final TableField<VImportLogRecord, LocalDateTime> IMPORT_DATE = createField(DSL.name("import_date"), SQLDataType.LOCALDATETIME(6), this, "");

    /**
     * The column <code>common_dd.v_import_log.state</code>.
     */
    public final TableField<VImportLogRecord, Integer> STATE = createField(DSL.name("state"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_import_log.description</code>.
     */
    public final TableField<VImportLogRecord, String> DESCRIPTION = createField(DSL.name("description"), SQLDataType.CLOB, this, "");

    private VImportLog(Name alias, Table<VImportLogRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VImportLog(Name alias, Table<VImportLogRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_import_log" as  SELECT m.description AS module,
          m.lastchange AS module_start,
          l.lastchange,
          l.pk,
          l.fk_import_log,
          l.pseudo_id,
          l.measure_id,
          l.import_date,
          l.state,
          l.description
         FROM (common_dd.t_import_log l
           JOIN common_dd.t_import_log m ON ((l.fk_import_log = m.pk)))
        ORDER BY l.pk DESC;
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_import_log</code> table reference
     */
    public VImportLog(String alias) {
        this(DSL.name(alias), V_IMPORT_LOG);
    }

    /**
     * Create an aliased <code>common_dd.v_import_log</code> table reference
     */
    public VImportLog(Name alias) {
        this(alias, V_IMPORT_LOG);
    }

    /**
     * Create a <code>common_dd.v_import_log</code> table reference
     */
    public VImportLog() {
        this(DSL.name("v_import_log"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VImportLog as(String alias) {
        return new VImportLog(DSL.name(alias), this);
    }

    @Override
    public VImportLog as(Name alias) {
        return new VImportLog(alias, this);
    }

    @Override
    public VImportLog as(Table<?> alias) {
        return new VImportLog(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VImportLog rename(String name) {
        return new VImportLog(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VImportLog rename(Name name) {
        return new VImportLog(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VImportLog rename(Table<?> name) {
        return new VImportLog(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VImportLog where(Condition condition) {
        return new VImportLog(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VImportLog where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VImportLog where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VImportLog where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VImportLog where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VImportLog where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VImportLog where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VImportLog where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VImportLog whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VImportLog whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
